--[[
	News info plguin
]]--


--------------------------------------
-- Create plugin

local RW = LibStub("AceAddon-3.0"):GetAddon("Raid Watch")
local plugin = RW:Plugin("News")
if not plugin then return end

--------------------------------------
-- Locals
local UIF
local AceGUI
local news = {}

--------------------------------------
-- Init

function plugin:OnRegister()
	self.db = RW.db:RegisterNamespace("News", {profile={}})
end

function plugin:PluginEnable()
	UIF = LibStub("AceGUI-Factory-1.0"):GetFactory("RW")
	AceGUI = LibStub("AceGUI-3.0")
end

function plugin:PluginDisable()
end

--------------------------------------
-- Options
function plugin:GetOptions()
	return 99, "News", self.GetGUI
end

function plugin:GetGUI()
	self = self or plugin
	
	local group, label, color, check
	
	group = AceGUI:Create("ScrollFrame")
	group:SetLayout("Flow")
	
	label = UIF:MainTitleLabel("News")
	group:AddChild(label)
	
	local igroup = UIF:InlineGroup("")
	group:AddChild(igroup)	
	
	for title, data in pairs(news) do
		local newsGroup = UIF:InlineGroup2(title)
		igroup:AddChild(newsGroup)
		
		self:GetNewsAsGUI(newsGroup, data, "")
	end
	
	return group
end

function plugin:GetNewsAsGUI(group, data, level)
	for i, subData in pairs(data) do
		if type(subData) == "table" then
			group:AddChild(UIF:NormalText(level.."* "..i))
			plugin:GetNewsAsGUI(group, subData, level.."       ")
		else
			group:AddChild(UIF:NormalText(level.."- "..subData))
		end
	end
end

news["1.20 Alpha"] = {
	["ICC"] = {
		["Testing"] = "Some mad info",
		["Blood-Queen Lana'Thel"] = {
			"Change 1",
			"Change 2",
		}
	},
	["General"] = {
		"General Info"
	}
}
