local mod = RW:Boss("Professor Putricide", "Icecrown Citadel", "The Plagueworks")
local L

mod.BossIcon = [[Interface\Icons\achievement_boss_profputricide]]

---------------------------
-- Variables
--Bloat
local iBloat, mBloat, wBloat, wBloatNewTargetSoon, tBloatCast, tBloatDur
--Volatile Ooze Adhesive 
local iVolatiel, mVolatile, wVolatile, tVolatileCast
--Puddle
local wPuddle, tPuddleCD
-- Unstable Experiment 
local wExperiment, tExperimentCast, tExperimentCD
-- Choking Gas 
local wGas, mGas, tGasDur
-- Choking Gas Bomb
local wGasBomb, tGasBombExplode, tGasBombCD
--Malleable Goo
local wMalleableGooHit, wMalleableGooRun, tMalleableGooDur, tMalleableGooCD, mMalleableGoo, iMalleableGoo, wMalleableGooH
-- Mutated Plague
local mMutatedP, tMutadedPDur, tMutadedPCD
-- Tear Gas
local tTearGasDur
-- Ooze slow
local tReguOozeDur

local tBerserk

-- Phases
local mPhase

---------------------------
-- Init	
function mod:OnRegister()
	L = mod:RegisterLocale("enUS")
	if L then
		L.name = "Professor Putricide"
		
		L.YellPull = "Good news, everyone! I think I perfected a plague that will destroy all life on Azeroth!"
		L.YellKill = "Bad news, everyone! I don't think I'm going to make it."
		
		L.bloat_new_tartget_soon = "New target for Gas Cloud Soon!"
		L.bloat_new_tartget_soon_opt = "Warn when the Gas Cloud is about to pick a new target"
		
		L.experiment_ooze = "Volatile Ooze"
		L.experiment_cloud = "Gas Cloud"
		
		L.experiment_cd = "Next Experiment: %s"
		L.experiment_cd_opt = "Timer for the next experiment type"
		
		L.experiment_cast = "Experiment: %s"
		L.experiment_cast_opt = "Cast bar for the experiment type"
		
		L.bombexplode = "Gas Bomb exloding"
		L.bombexplode_opt = "Timer for when the bombs explode"
		
		L.adds = "Gas Cloud/Ooze"
	end
	L = mod:GetLocale()
	mod.L = L
	
	mod:SetTrigger(36678, L.YellPull)
	mod:SetWin(36678, L.YellKill)
	
	self:AddToCategory(L.name, 71968, 72460, 72451, 72297, 71255, 72868, 71617)
	self:AddToCategory(L.adds , 70215, 72838, 70539)
	
	tBerserk		= self:BerserkTimer(600)
	
	tBloatCast		= self:CastTimer(3, 70215)
	tBloatDur		= self:DurTargetTimer(20, 70215)
	tVolatileCast	= self:CastTimer(3, 72838)
	tExperimentCast = self:CustomTimer(2.5, L.experiment_cast, L.experiment_cast_opt, 71968)
	tExperimentCD	= self:CustomTimer(40, L.experiment_cd, L.experiment_cd_opt, 71968)
	tGasDur			= self:DurTargetTimer(17, 72460, nil, nil, false)
	tGasBombExplode = self:CustomTimer(20, L.bombexplode, L.bombexplode_opt, 71255)
	tGasBombCD		= self:CDTimer(35, 71255)
	tMutadedPDur	= self:DurTargetStackTimer(50, 72451, nil, nil, false)
	tMutadedPCD		= self:CDTimer(10, 72451, nil, nil, false)
	tTearGasDur		= self:DurTimer(15, 71617)
	tMalleableGooDur = self:DurTargetTimer(20, 72297, nil, nil, false)
	tMalleableGooCD = self:CDTimer(25, 72297)
	tPuddleCD		= self:CDTimer(35, 72868)
	tReguOozeDur	= self:DurTimer(20, 70539, nil, nil, false)
	
	wBloat			= self:RunawayWarning(70215)
	wBloatNewTargetSoon = self:CustomWarning(L.bloat_new_tartget_soon, L.bloat_new_tartget_soon_opt, 70215)
	wVolatile		= self:Warning(72838)
	wPuddle			= self:RunawayWarning(72868)
	wExperiment		= self:CastWarning(71968)
	wGasBomb		= self:CastWarning(71255)
	wGas			= self:InformWarning(72460)
	wMalleableGooHit = self:InformWarning(72297)
	wMalleableGooRun = self:RunawayWarning(72297)
	wMalleableGooH	= self:Warning(72297)
	
	mBloat			= self:TargetMessage(70215)
	mVolatile		= self:TargetMessage(72838)
	mGas			= self:TargetMessage(72460, nil, nil, false)
	mMutatedP		= self:TargetStackMessage(72451, nil, nil, false)
	mMalleableGoo	= self:TargetMessage(72297)
	mPhase			= self:PhaseMessage()
	
	iBloat			= self:Icon("SKULL", 70215, false)
	iVolatiel		= self:Icon("SKULL", 72838, false)
	iMalleableGoo	= self:Icon("CROSS", 72297, false, 8)
end

---------------------------
-- Locals
local tearGasSpamm
local phase
local nextExperiment

local oozeIcon = select(3, GetSpellInfo(72838))
local gasIcon = select(3, GetSpellInfo(70215))

---------------------------
-- Start
function mod:OnEngage(trigger)
	self:Track("Bloat", 70215, 72860, 72859, 72858, 72832, 72833, 72455, 70672)
	self:Track("Volatile", 72838, 70447, 72836, 72837)
	self:Track("Puddle", 72868, 70346, 72869, 70341)
	self:Track("Experiment", 71968, 70351, 71966, 71967)
	self:Track("GasBomb", 71255)
	self:Track("Gas", 72460, 71278, 72620, 72619)
	self:Track("MalleableGoo", 72297, 70853, 72458, 72548, 72549, 72550, 72873, 72874, 72295, 72296, 70852, 72615)
	self:Track("MutadedP", 72451, 72672, 72671, 72463,   72506, 72454, 72507, 72464)
	self:Track("TearGas", 71617, 71615, 71618)
	self:Track("OozeSlow", 70539)
	
	tearGasSpamm = 0
	phase = 1
	
	nextExperiment = 1
	
	tPuddleCD:Start(10)
	tExperimentCast:SetIcon(oozeIcon)
	tExperimentCD:Start(nil, L.experiment_ooze)
	tBerserk:Start()
end

function mod:Bloat(event, args)
	if event == "SPELL_CAST_START" then
		tBloatCast:Start()

	elseif event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			wBloat:Show()
		end
		mBloat:Show(args.dName)
		tBloatDur:Start(args.dName)
		iBloat:Show(args.dName)
	end
end

function mod:Volatile(event, args)
	if event == "SPELL_CAST_START" then
		tVolatileCast:Start()

	elseif event == "SPELL_AURA_APPLIED" then
		iVolatiel:Show(args.dName)
		mVolatile:Show(args.dName)
		if not args:IsPlayer() then
			wVolatile:Show()
		end
	end
end

function mod:Puddle(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			wPuddle:Show()
		end
	elseif event == "SPELL_CAST_SUCCESS" then
		if phase < 3 then
			tPuddleCD:Start()
		else
			tPuddleCD:Start(20)
		end
	end
end

function mod:Experiment(event, args)
	if event == "SPELL_CAST_START" then
		if nextExperiment == 1 then
			tExperimentCast:SetIcon(oozeIcon)
			wExperiment:Show()
			tExperimentCast:Start(nil, L.experiment_ooze)
			tExperimentCD:SetIcon(gasIcon)
			tExperimentCD:Start(nil, L.experiment_cloud)
			nextExperiment = 2
		else
			tExperimentCast:SetIcon(gasIcon)
			wExperiment:Show()
			tExperimentCast:Start(nil, L.experiment_cloud)
			tExperimentCD:SetIcon(oozeIcon)
			tExperimentCD:Start(nil, L.experiment_ooze)
			nextExperiment = 1
		end
	end
end

function mod:GasBomb(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tGasBombCD:Start()
		tGasBombExplode:Start()
		wGasBomb:Show()
	end
end

function mod:Gas(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			wGas:Show()
			tGasDur:Start(args.dName)
		end
		mGas:Show(args.dName)
	end
end

function mod:targetScan()
	local target = self:GetMobTarget(36678)
	if target then
		iMalleableGoo:Show(target)
		mMalleableGoo:Show(target)
		if target == self.pName then
			wMalleableGooRun:Show()
			SendChatMessage("Goo on me!", "SAY")
		elseif self.Party.group[target] then
			local uID = self.Party.group[target].id
			if uID and CheckInteractDistance(uID, 2) then
				wMalleableGooRun:Show()
			end
		end
	end
end

function mod:MalleableGoo(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			wMalleableGooHit:Show()
			tMalleableGooDur:Start(args.dName)
		end
		
	elseif event == "SPELL_AURA_REMOVED" then
		tMalleableGooDur:Stop(args.dName)
		
	elseif event == "SPELL_CAST_SUCCESS" then
		self:Schedule("GooTarget", 0.08, "targetScan")
		tMalleableGooCD:Start()
		wMalleableGooH:Show()
	end
end

function mod:MutadedP(event, args)
	if event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_APPLIED_DOSE" then
		mMutatedP:Show(args.dName, args.amount or 1)
		tMutadedPDur:Start(args.dName, args.amount or 1)
		tMutadedPCD:Start()
		
	elseif event == "SPELL_AURA_REMOVED" then
		tMutadedPDur:Stop(args.dName)
	end
end

function mod:OozeSlow(event, args)
	if event == "SPELL_AURA_APPLIED" then
		tReguOozeDur:Start()
	
	elseif event == "SPELL_AURA_REMOVED" then
		tReguOozeDur:Stop()
	end
end	

function mod:TearGas(event, args)
	if event == "SPELL_CAST_START" then
		phase = phase + 1
		mPhase:Show(phase)
		
		if phase >= 3 then
			tExperimentCD:Stop()
		end
	
	elseif event == "SPELL_AURA_APPLIED" and (GetTime() - tearGasSpamm) > 2 then
		tTearGasDur:Start()
	end
end