local mod = RW:Boss("Koralon the Flame Watcher", "Vault of Archavon")
local L

mod.BossIcon = [[Interface\Icons\spell_fire_totemofwrath]]

---------------------------
-- Variables
local tFuryCD, tBreath, tFistDur, tFistCD
local wCinder
local wBreath
local mFury
local wFist

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Koralon the Flame Watcher"
		L.fury = GetSpellInfo(66721).." x %d"
		L.fury_opt = "Show the stack count"
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(35013)
	self:SetWin()
	
	tFistDur 	= self:DurTimer(15, 66725)
	tFistCD	 	= self:CDTimer(47, 66725)
	tFuryCD 	= self:CustomTimer(20, L.fury, L.fury_opt, 66721)
	tBreath 	= self:CastTimer(4.5, 66665)
	wBreath 	= self:CastWarning(66665)
	wCinder 	= self:RunawayWarning(67332)
	wFist 		= self:Warning(66725, nil, nil, false)
	mFury 		= self:CustomMessage(L.fury, L.fury_opt, 66721)
	
end

---------------------------
-- Locals

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("Fury", 66721)
	self:Track("Cinder", 67332, 66684)
	self:Track("Breath", 66665, 67328)
	self:Track("Fist", 66725, 66808, 68160, 68161)

	tFuryCD:Start(nil, 1)
end

function mod:Fury(event, args)
	if event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_APPLIED_DOSE" then
		tFuryCD:Start(nil, args.amount and args.amount + 1 or 1)
		mFury:Show(args.amount or 1)
	end
end

function mod:Cinder(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			wCinder:Show()
		end
	end
end

function mod:Breath(event, args)
	if event == "SPELL_CAST_START" then
		wBreath:Show()
		tBreath:Start()
	end
end

function mod:Fist(event, args)
	if event == "SPELL_CAST_START" then
		tFistDur:Start()
		tFistCD:Start()
		wFist:Show()
	end
end